.386

.MODEL FLAT, STDCALL

OPTION CASEMAP:NONE

INCLUDE    \masm32\include\windows.inc
INCLUDE    \masm32\include\user32.inc
INCLUDE    \masm32\include\comdlg32.inc
INCLUDE    \masm32\include\gdi32.inc
INCLUDE    \masm32\include\kernel32.inc
INCLUDELIB \masm32\lib\gdi32.lib
INCLUDELIB \masm32\lib\comdlg32.lib
INCLUDELIB \masm32\lib\user32.lib
INCLUDELIB \masm32\lib\kernel32.lib

WinMain PROTO :DWORD, :DWORD, :DWORD, :DWORD

WORDINFO STRUCT
    WordLen  DD ? ; dugo sowa: uywane do szybkiego porwnywania
    pszWord  DD ? ; wskazanie sowa
    pColor   DD ? ; wskazanie koloru podwietlenia
    NextLink DD ? ; wskazanie nastpnej struktury WORDINFO
WORDINFO ENDS

.CONST

IDR_MAINMENU     EQU   101
IDD_OPTIONDLG    EQU   101
IDD_FINDDLG      EQU   102
IDD_GOTODLG      EQU   103
IDD_REPLACEDLG   EQU   104
IDR_MAINACCEL    EQU   105

RichEditID       EQU   300

IDC_BACKCOLORBOX EQU  1000
IDC_TEXTCOLORBOX EQU  1001
IDC_FINDEDIT     EQU  1000
IDC_MATCHCASE    EQU  1001
IDC_REPLACEEDIT  EQU  1001
IDC_WHOLEWORD    EQU  1002
IDC_DOWN         EQU  1003
IDC_UP           EQU  1004
IDC_LINENO       EQU  1005

IDM_OPEN         EQU 40001
IDM_SAVE         EQU 40002
IDM_CLOSE        EQU 40003
IDM_SAVEAS       EQU 40004
IDM_EXIT         EQU 40005
IDM_COPY         EQU 40006
IDM_CUT          EQU 40007
IDM_PASTE        EQU 40008
IDM_DELETE       EQU 40009
IDM_SELECTALL    EQU 40010
IDM_OPTION       EQU 40011
IDM_UNDO         EQU 40012
IDM_REDO         EQU 40013
IDM_FIND         EQU 40014
IDM_FINDNEXT     EQU 40015
IDM_REPLACE      EQU 40016
IDM_GOTOLINE     EQU 40017
IDM_FINDPREV     EQU 40018

.DATA

ClassName       DB "IczEditClass", 0
AppName         DB "IczEdit wersja 3.0", 0
RichEditDLL     DB "riched20.dll", 0
RichEditClass   DB "RichEdit20A", 0
NoRichEdit      DB "Nie mona odnale biblioteki riched20.dll", 0
ASMFilterString DB "Kod rdowy ASM (*.asm)", 0, "*.asm", 0, 
                   "Wszystkie pliki (*.*)", 0, "*.*", 0, 0
OpenFileFail    DB "Nie mona otworzy pliku", 0
WannaSave       DB "Dane w edytorze zostay zmodyfikowane. Zapisa je?", 0
FileOpened      DD FALSE
BackgroundColor DD 0FFFFFFh ; standardowy kolor ta - biay
TextColor       DD 0        ; standardowy kolor tekstu - czarny
WordFileName    DB "\wordfile.txt", 0
ASMSection      DB "ASSEMBLY", 0
C1Key           DB "C1", 0, 0
C2Key           DB "C2", 0, 0
C3Key           DB "C3", 0, 0
C4Key           DB "C4", 0, 0
C5Key           DB "C5", 0, 0
C6Key           DB "C6", 0, 0
C7Key           DB "C7", 0, 0
C8Key           DB "C8", 0, 0
C9Key           DB "C9", 0, 0
C10Key          DB "C10", 0
ZeroString      DB 0
ASMColorArray   DD 0FF0000h, 0805F50h, 0FFh, 666F00h, 44F0h,
                   5F8754h, 4 DUP(0FF0000h)
CmntColor       DD 808000h

.DATA?

hInstance         DD ?
hRichEdit         DD ?
hwndRichEdit      DD ?
FileName          DB 256 DUP(?)
AlternateFileName DB 256 DUP(?)
CustomColors      DD  16 DUP(?)
FindBuffer        DB 256 DUP(?)
ReplaceBuffer     DB 256 DUP(?)
uFlags            DD ?
findtext          FINDTEXTEX <>
ASMSyntaxArray    DD 256 DUP(?)
hSearch           DD ?        ; uchwyt okna dialogowego szukania/zamiany
hAccel            DD ?
hMainHeap         DD ?        ; uchwyt stosu
OldWndProc        DD ?
RichEditVersion   DD ?

.CODE

start:
    mov    BYTE PTR [FindBuffer], 0
    mov    BYTE PTR [ReplaceBuffer], 0
    INVOKE GetModuleHandle, NULL
    mov    hInstance, eax
    INVOKE LoadLibrary, ADDR RichEditDLL
    .IF eax!=0
        mov    hRichEdit, eax
        INVOKE GetProcessHeap
        mov    hMainHeap, eax

; adujemy sowa, ktre bd podwietlane

        call   FillHiliteInfo
        INVOKE WinMain, hInstance, 0, 0, SW_SHOWDEFAULT
        INVOKE FreeLibrary, hRichEdit
    .ELSE
        INVOKE MessageBox, 0, ADDR NoRichEdit, ADDR AppName,
                           MB_OK OR MB_ICONERROR
    .ENDIF
    INVOKE ExitProcess, eax
    
WinMain PROC hInst:DWORD, hPrevInst:DWORD, CmdLine:DWORD, CmdShow:DWORD

LOCAL wc:   WNDCLASSEX
LOCAL msg:  MSG
LOCAL hwnd: DWORD

    mov    wc.cbSize, SIZEOF WNDCLASSEX
    mov    wc.style, CS_HREDRAW OR CS_VREDRAW
    mov    wc.lpfnWndProc, OFFSET WndProc
    mov    wc.cbClsExtra, NULL
    mov    wc.cbWndExtra, NULL
    push   hInst
    pop    wc.hInstance
    mov    wc.hbrBackground, COLOR_WINDOW+1
    mov    wc.lpszMenuName, IDR_MAINMENU
    mov    wc.lpszClassName, OFFSET ClassName
    INVOKE LoadIcon, NULL, IDI_APPLICATION
    mov    wc.hIcon, eax
    mov    wc.hIconSm, eax
    INVOKE LoadCursor, NULL, IDC_ARROW
    mov    wc.hCursor, eax
    INVOKE RegisterClassEx, ADDR wc
    INVOKE CreateWindowEx, NULL, ADDR ClassName, ADDR AppName,
                           WS_OVERLAPPEDWINDOW, CW_USEDEFAULT,
                           CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
                           NULL, NULL, hInst, NULL
    mov    hwnd, eax
    INVOKE ShowWindow, hwnd, SW_SHOWNORMAL
    INVOKE UpdateWindow, hwnd
    INVOKE LoadAccelerators, hInstance, IDR_MAINACCEL
    mov    hAccel, eax

    .WHILE TRUE
        INVOKE GetMessage, ADDR msg, 0, 0, 0
        .BREAK .IF (!eax)
        INVOKE IsDialogMessage, hSearch, ADDR msg
        .IF eax==FALSE
            INVOKE TranslateAccelerator, hwnd, hAccel, ADDR msg
            .IF eax==0
                INVOKE TranslateMessage, ADDR msg
                INVOKE DispatchMessage, ADDR msg
            .ENDIF
        .ENDIF
    .ENDW
    mov   eax, msg.wParam
    ret

WinMain ENDP

StreamInProc PROC hFile:      DWORD,
                  pBuffer:    DWORD,
                  NumBytes:   DWORD,
                  pBytesRead: DWORD

    INVOKE ReadFile, hFile, pBuffer, NumBytes, pBytesRead, 0
    xor    eax, 1
    ret

StreamInProc ENDP

StreamOutProc PROC hFile:         DWORD,
                   pBuffer:       DWORD,
                   NumBytes:      DWORD,
                   pBytesWritten: DWORD

    INVOKE WriteFile, hFile, pBuffer, NumBytes, pBytesWritten, 0
    xor    eax, 1
    ret

StreamOutProc ENDP

CheckModifyState PROC hWnd:DWORD

    INVOKE SendMessage, hwndRichEdit, EM_GETMODIFY, 0, 0
    .IF eax!=0
        INVOKE MessageBox, hWnd, ADDR WannaSave, ADDR AppName,
                           MB_YESNOCANCEL
        .IF eax==IDYES
            INVOKE SendMessage, hWnd, WM_COMMAND, IDM_SAVE, 0
        .ELSEIF eax==IDCANCEL
            mov eax, FALSE
            ret
        .ENDIF
    .ENDIF
    mov eax, TRUE
    ret

CheckModifyState ENDP

SetColor PROC

LOCAL cfm: CHARFORMAT    

    INVOKE SendMessage, hwndRichEdit, EM_SETBKGNDCOLOR, 0,
                        BackgroundColor
    INVOKE RtlZeroMemory, ADDR cfm, SIZEOF cfm
    mov    cfm.cbSize, SIZEOF cfm
    mov    cfm.dwMask, CFM_COLOR
    push   TextColor
    pop    cfm.crTextColor
    INVOKE SendMessage, hwndRichEdit, EM_SETCHARFORMAT, SCF_ALL, ADDR cfm
    ret

SetColor ENDP

OptionProc PROC hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

LOCAL clr: CHOOSECOLOR

    .IF uMsg==WM_INITDIALOG
    .ELSEIF uMsg==WM_COMMAND
        mov ax, WORD PTR wParam + 2
        .IF ax==BN_CLICKED
            mov eax, wParam
            .IF ax==IDCANCEL
                INVOKE SendMessage, hWnd, WM_CLOSE, 0, 0
            .ELSEIF ax==IDC_BACKCOLORBOX
                INVOKE RtlZeroMemory, ADDR clr, SIZEOF clr
                mov    clr.lStructSize, SIZEOF clr
                push   hWnd
                pop    clr.hwndOwner
                push   hInstance
                pop    clr.hInstance
                push   BackgroundColor
                pop    clr.rgbResult
                mov    clr.lpCustColors, OFFSET CustomColors
                mov    clr.Flags, CC_ANYCOLOR OR CC_RGBINIT
                INVOKE ChooseColor, ADDR clr
                .IF eax!=0
                    push   clr.rgbResult
                    pop    BackgroundColor
                    INVOKE GetDlgItem, hWnd, IDC_BACKCOLORBOX
                    INVOKE InvalidateRect, eax, 0, TRUE
                .ENDIF
            .ELSEIF ax==IDC_TEXTCOLORBOX
                INVOKE RtlZeroMemory, ADDR clr, SIZEOF clr
                mov    clr.lStructSize, SIZEOF clr
                push   hWnd
                pop    clr.hwndOwner
                push   hInstance
                pop    clr.hInstance
                push   TextColor
                pop    clr.rgbResult
                mov    clr.lpCustColors, OFFSET CustomColors
                mov    clr.Flags, CC_ANYCOLOR OR CC_RGBINIT
                INVOKE ChooseColor, ADDR clr
                .IF eax!=0
                    push   clr.rgbResult
                    pop    TextColor
                    INVOKE GetDlgItem, hWnd, IDC_TEXTCOLORBOX
                    INVOKE InvalidateRect, eax, 0, TRUE
                .ENDIF
            .ELSEIF ax==IDOK

; Zachowujemy stan modyfikacji kontrolki RichEdit, poniewa zmiana
; koloru zmienia rwnie stan modyfikacji

                INVOKE SendMessage, hwndRichEdit, EM_GETMODIFY, 0, 0
                push   eax
                INVOKE SetColor
                pop    eax
                INVOKE SendMessage, hwndRichEdit, EM_SETMODIFY, eax, 0
                INVOKE EndDialog, hWnd, 0
            .ENDIF
        .ENDIF
    .ELSEIF uMsg==WM_CTLCOLORSTATIC
        INVOKE GetDlgItem, hWnd, IDC_BACKCOLORBOX
        .IF eax==lParam
            INVOKE CreateSolidBrush, BackgroundColor            
            ret
        .ELSE
            INVOKE GetDlgItem, hWnd, IDC_TEXTCOLORBOX
            .IF eax==lParam
                INVOKE CreateSolidBrush, TextColor
                ret
            .ENDIF
        .ENDIF
        mov eax, FALSE
        ret
    .ELSEIF uMsg==WM_CLOSE
        INVOKE EndDialog, hWnd, 0
    .ELSE
        mov eax, FALSE
        ret
    .ENDIF
    mov eax, TRUE
    ret

OptionProc ENDP

SearchProc PROC hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

    .IF uMsg==WM_INITDIALOG
        push hWnd
        pop  hSearch

; Standardowo wybieramy opcj poszukiwa w d

        INVOKE CheckRadioButton, hWnd, IDC_DOWN, IDC_UP, IDC_DOWN
        INVOKE SendDlgItemMessage, hWnd, IDC_FINDEDIT, WM_SETTEXT, 0,
                                   ADDR FindBuffer
    .ELSEIF uMsg==WM_COMMAND
        mov ax, WORD PTR wParam + 2
        .IF ax==BN_CLICKED
            mov eax, wParam
            .IF ax==IDOK
                mov uFlags, 0
                INVOKE SendMessage, hwndRichEdit, EM_EXGETSEL, 0,
                                    ADDR findtext.chrg
                INVOKE GetDlgItemText, hWnd, IDC_FINDEDIT,
                                       ADDR FindBuffer, SIZEOF FindBuffer
                .IF eax!=0
                    INVOKE IsDlgButtonChecked, hWnd, IDC_DOWN
                    .IF eax==BST_CHECKED
                        or  uFlags, FR_DOWN
                        mov eax, findtext.chrg.cpMin
                        .IF eax!=findtext.chrg.cpMax
                            push findtext.chrg.cpMax
                            pop  findtext.chrg.cpMin
                        .ENDIF
                        mov findtext.chrg.cpMax, -1
                    .ELSE
                        mov findtext.chrg.cpMax, 0
                    .ENDIF
                    INVOKE IsDlgButtonChecked, hWnd, IDC_MATCHCASE
                    .IF eax==BST_CHECKED
                        or uFlags, FR_MATCHCASE
                    .ENDIF
                    INVOKE IsDlgButtonChecked, hWnd, IDC_WHOLEWORD
                    .IF eax==BST_CHECKED
                        or uFlags, FR_WHOLEWORD
                    .ENDIF
                    mov    findtext.lpstrText, OFFSET FindBuffer
                    INVOKE SendMessage, hwndRichEdit, EM_FINDTEXTEX,
                                        uFlags, ADDR findtext
                    .IF eax!=-1
                        INVOKE SendMessage, hwndRichEdit, EM_EXSETSEL,
                                            0, ADDR findtext.chrgText
                    .ENDIF
                .ENDIF
            .ELSEIF ax==IDCANCEL
                INVOKE SendMessage, hWnd, WM_CLOSE, 0, 0
            .ELSE
                mov eax, FALSE
                ret
            .ENDIF
        .ENDIF
    .ELSEIF uMsg==WM_CLOSE
        mov    hSearch, 0
        INVOKE EndDialog, hWnd, 0
    .ELSE
        mov eax, FALSE
        ret
    .ENDIF
    mov eax, TRUE
    ret

SearchProc ENDP

ReplaceProc PROC hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

LOCAL settext: SETTEXTEX

    .IF uMsg==WM_INITDIALOG
        push   hWnd
        pop    hSearch
        INVOKE SetDlgItemText, hWnd, IDC_FINDEDIT, ADDR FindBuffer
        INVOKE SetDlgItemText, hWnd, IDC_REPLACEEDIT, ADDR ReplaceBuffer
    .ELSEIF uMsg==WM_COMMAND
        mov ax, WORD PTR wParam + 2
        .IF ax==BN_CLICKED
            mov eax, wParam
            .IF ax==IDCANCEL
                INVOKE SendMessage, hWnd, WM_CLOSE, 0, 0
            .ELSEIF ax==IDOK
                INVOKE GetDlgItemText, hWnd, IDC_FINDEDIT,
                                       ADDR FindBuffer, SIZEOF FindBuffer
                INVOKE GetDlgItemText, hWnd, IDC_REPLACEEDIT,
                                       ADDR ReplaceBuffer, SIZEOF ReplaceBuffer

; Sprawdzamy, czy teksty do znalezienia i zastpienia s rne. Jeli
; tak, to wykonujemy operacj zastpienia. W przeciwnym wypadku nic
; nie robimy. Sprawdzenie to jest konieczne, poniewa moe doj do
; zablokowania aplikacji z uwagi na przyjty sposb pracy tej procedury.

                INVOKE lstrcmp, ADDR FindBuffer, ADDR ReplaceBuffer
                .IF eax!=0
                    mov findtext.chrg.cpMin, 0
                    mov findtext.chrg.cpMax, -1
                    mov findtext.lpstrText, OFFSET FindBuffer
                    mov settext.flags, ST_SELECTION
                    mov settext.codepage, CP_ACP
                    .WHILE TRUE
                        INVOKE SendMessage, hwndRichEdit, EM_FINDTEXTEX,
                                            FR_DOWN OR FR_MATCHCASE, ADDR findtext
                        .BREAK .IF eax==-1
                        INVOKE SendMessage, hwndRichEdit, EM_EXSETSEL, 0,
                                            ADDR findtext.chrgText
                        INVOKE SendMessage, hwndRichEdit, EM_SETTEXTEX,
                                            ADDR settext, ADDR ReplaceBuffer
                    .ENDW
                .ENDIF
            .ENDIF
        .ENDIF
    .ELSEIF uMsg==WM_CLOSE
        mov    hSearch, 0
        INVOKE EndDialog, hWnd, 0
    .ELSE
        mov eax, FALSE
        ret
    .ENDIF
    mov eax, TRUE
    ret

ReplaceProc ENDP

GoToProc PROC hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

LOCAL LineNo: DWORD
LOCAL chrg:   CHARRANGE

    .IF uMsg==WM_INITDIALOG
        push hWnd
        pop  hSearch
    .ELSEIF uMsg==WM_COMMAND
        mov ax, WORD PTR wParam + 2
        .IF ax==BN_CLICKED
            mov eax, wParam
            .IF ax==IDCANCEL
                INVOKE SendMessage, hWnd, WM_CLOSE, 0, 0
            .ELSEIF ax==IDOK
                INVOKE GetDlgItemInt, hWnd, IDC_LINENO, NULL, FALSE
                mov    LineNo, eax
                INVOKE SendMessage, hwndRichEdit, EM_GETLINECOUNT, 0, 0
                .IF eax>LineNo
                    INVOKE SendMessage, hwndRichEdit, EM_LINEINDEX,
                                        LineNo, 0
                    INVOKE SendMessage, hwndRichEdit, EM_SETSEL, eax, eax
                    INVOKE SetFocus, hwndRichEdit
                .ENDIF
            .ENDIF
        .ENDIF
    .ELSEIF uMsg==WM_CLOSE
        mov    hSearch, 0
        INVOKE EndDialog, hWnd, 0
    .ELSE
        mov eax, FALSE
        ret
    .ENDIF
    mov eax, TRUE
    ret

GoToProc ENDP

PrepareEditMenu PROC hSubMenu:DWORD

LOCAL chrg: CHARRANGE

; Sprawdzamy, czy w schowku jest jaki tekst.
; Jeli tak, to uaktywniamy element menu Wklej

    INVOKE SendMessage, hwndRichEdit, EM_CANPASTE, CF_TEXT, 0
    .IF eax==0        ; w schowku brak tekstu
        INVOKE EnableMenuItem, hSubMenu, IDM_PASTE, MF_GRAYED
    .ELSE
        INVOKE EnableMenuItem, hSubMenu, IDM_PASTE, MF_ENABLED
    .ENDIF

; Sprawdzamy, czy kolejka cofni jest pusta

    INVOKE SendMessage, hwndRichEdit, EM_CANUNDO, 0, 0
    .IF eax==0
        INVOKE EnableMenuItem, hSubMenu, IDM_UNDO, MF_GRAYED
    .ELSE
        INVOKE EnableMenuItem, hSubMenu, IDM_UNDO, MF_ENABLED
    .ENDIF

; Sprawdzamy, czy kolejka ponowie jest pusta

    INVOKE SendMessage, hwndRichEdit, EM_CANREDO, 0, 0
    .IF eax==0
        INVOKE EnableMenuItem, hSubMenu, IDM_REDO, MF_GRAYED
    .ELSE
        INVOKE EnableMenuItem, hSubMenu, IDM_REDO, MF_ENABLED
    .ENDIF

; Sprawdzamy, czy w kontrolce RichEdit istnieje biece zaznaczenie
; Jeli tak, wczamy elementy menu Wytnij/Kopiuj/Usu

    INVOKE SendMessage, hwndRichEdit, EM_EXGETSEL, 0, ADDR chrg
    mov    eax, chrg.cpMin
    .IF eax==chrg.cpMax        ; brak biecego wyboru
        INVOKE EnableMenuItem, hSubMenu, IDM_COPY, MF_GRAYED
        INVOKE EnableMenuItem, hSubMenu, IDM_CUT, MF_GRAYED
        INVOKE EnableMenuItem, hSubMenu, IDM_DELETE, MF_GRAYED
    .ELSE
        INVOKE EnableMenuItem, hSubMenu, IDM_COPY, MF_ENABLED
        INVOKE EnableMenuItem, hSubMenu, IDM_CUT, MF_ENABLED
        INVOKE EnableMenuItem, hSubMenu, IDM_DELETE, MF_ENABLED
    .ENDIF
    ret

PrepareEditMenu ENDP

ParseBuffer PROC USES edi esi hHeap:       DWORD,
                              pBuffer:     DWORD,
                              nSize:       DWORD,
                              ArrayOffset: DWORD,
                              pArray:      DWORD
LOCAL buffer[128]: BYTE
LOCAL InProgress:  DWORD

    mov    InProgress, FALSE
    lea    esi, buffer
    mov    edi, pBuffer
    INVOKE CharLower, edi
    mov    ecx, nSize

SearchLoop:

    or     ecx, ecx
    jz     Finished
    cmp    BYTE PTR [edi], " "
    je     EndOfWord
    cmp    BYTE PTR [edi], 9     ; tab
    je     EndOfWord
    mov    InProgress, TRUE
    mov    al, BYTE PTR [edi]
    mov    BYTE PTR [esi], al
    inc    esi

SkipIt:

    inc    edi
    dec    ecx
    jmp    SearchLoop

EndOfWord:

    cmp    InProgress, TRUE
    je     WordFound
    jmp    SkipIt

WordFound:

    mov    BYTE PTR [esi], 0
    push   ecx

; umieszczamy sowo w strukturze WORDINFO

    INVOKE HeapAlloc, hHeap, HEAP_ZERO_MEMORY, SIZEOF WORDINFO
    push   esi
    mov    esi, eax

ASSUME esi:PTR WORDINFO

    INVOKE lstrlen, ADDR buffer
    mov    [esi].WordLen, eax
    push   ArrayOffset
    pop    [esi].pColor
    inc    eax
    INVOKE HeapAlloc, hHeap, HEAP_ZERO_MEMORY, eax
    mov    [esi].pszWord, eax
    mov    edx, eax
    INVOKE lstrcpy, edx, ADDR buffer
    mov    eax, pArray
    movzx  edx, BYTE PTR [buffer]
    shl    edx, 2      ; mnoenie przez 4
    add    eax, edx
    .IF DWORD PTR [eax]==0
        mov DWORD PTR [eax], esi
    .ELSE
        push DWORD PTR [eax]
        pop  [esi].NextLink
        mov  DWORD PTR [eax], esi
    .ENDIF
    pop esi
    pop ecx
    lea esi, buffer
    mov InProgress, FALSE
    jmp SkipIt

Finished:

    .IF InProgress==TRUE

; Umieszczamy sowo w strukturze WORDINFO

        INVOKE HeapAlloc, hHeap, HEAP_ZERO_MEMORY, SIZEOF WORDINFO
        push   esi
        mov    esi, eax

ASSUME esi:PTR WORDINFO

        INVOKE lstrlen, ADDR buffer
        mov    [esi].WordLen, eax
        push   ArrayOffset
        pop    [esi].pColor
        inc    eax
        INVOKE HeapAlloc, hHeap, HEAP_ZERO_MEMORY, eax
        mov    [esi].pszWord, eax
        mov    edx, eax
        INVOKE lstrcpy, edx, ADDR buffer
        mov    eax, pArray
        movzx  edx, BYTE PTR [buffer]
        shl    edx, 2        ; mnoenie przez 4
        add    eax, edx
        .IF DWORD PTR [eax]==0
            mov DWORD PTR [eax], esi
        .ELSE
            push DWORD PTR [eax]
            pop  [esi].NextLink
            mov  DWORD PTR [eax], esi
        .ENDIF
        pop esi
    .ENDIF
    ret

ParseBuffer ENDP

FillHiliteInfo PROC uses edi

LOCAL buffer[1024]: BYTE
LOCAL pTemp:        DWORD
LOCAL BlockSize:    DWORD

; Zerujemy tablic

    INVOKE RtlZeroMemory, ADDR ASMSyntaxArray, SIZEOF ASMSyntaxArray

; Odczytujemy ciek dyskow tego egzemplarza aplikacji

    INVOKE GetModuleFileName, hInstance, ADDR buffer, SIZEOF buffer
    INVOKE lstrlen, ADDR buffer
    mov    ecx, eax
    dec    ecx
    lea    edi, buffer
    add    edi, ecx
    std
    mov    al, "\"
    repne  scasb
    cld
    inc    edi
    mov    BYTE PTR [edi], 0
    INVOKE lstrcat, ADDR buffer, ADDR WordFileName

; Sprawdzamy istnienie pliku

    INVOKE GetFileAttributes, ADDR buffer
    .IF eax!=-1

; Przydzielamy ze stosu blok pamici na acuchy znakowe

        mov    BlockSize, 1024*10
        INVOKE HeapAlloc, hMainHeap, 0, BlockSize
        mov    pTemp, eax
        mov    ecx, OFFSET C1Key
        
@@:        
        push   ecx
        INVOKE GetPrivateProfileString, ADDR ASMSection, ecx,
                                        ADDR ZeroString, pTemp,
                                        BlockSize, ADDR buffer
        pop    ecx
        .IF eax!=0
            inc eax
            .IF eax==BlockSize    ; bufor jest za may
                add    BlockSize, 1024*10
                push   ecx
                INVOKE HeapReAlloc, hMainHeap, 0, pTemp, BlockSize
                pop    ecx
                mov    pTemp, eax
                jmp    @B
            .ENDIF
            mov    edx, ecx
            sub    edx, OFFSET C1Key
            add    edx, OFFSET ASMColorArray
            push   ecx
            INVOKE ParseBuffer, hMainHeap, pTemp, eax, edx,
                                ADDR ASMSyntaxArray
            pop    ecx
        .ENDIF
        add ecx, 4
        cmp ecx, 4 + OFFSET C10Key
        jne @B
        
        INVOKE HeapFree, hMainHeap, 0, pTemp
    .ENDIF
    ret

FillHiliteInfo ENDP

NewRichEditProc PROC hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

LOCAL hdc:             DWORD
LOCAL hOldFont:        DWORD
LOCAL FirstChar:       DWORD
LOCAL rect:            RECT
LOCAL txtrange:        TEXTRANGE
LOCAL buffer[1024*10]: BYTE
LOCAL hRgn:            DWORD
LOCAL hOldRgn:         DWORD
LOCAL RealRect:        RECT
LOCAL pString:         DWORD
LOCAL BufferSize:      DWORD
LOCAL pt:              POINT

    .IF uMsg==WM_PAINT
        push   edi
        push   esi
        INVOKE HideCaret, hWnd
        INVOKE CallWindowProc, OldWndProc, hWnd, uMsg, wParam, lParam
        push   eax
        mov    edi, OFFSET ASMSyntaxArray
        INVOKE GetDC, hWnd
        mov    hdc, eax
        INVOKE SetBkMode, hdc, TRANSPARENT

; Tutaj podwietlamy skadni

        INVOKE SendMessage, hWnd, EM_GETRECT, 0, ADDR rect
        INVOKE SendMessage, hWnd, EM_CHARFROMPOS, 0, ADDR rect

; Odczytujemy numer wiersza

        INVOKE SendMessage, hWnd, EM_LINEFROMCHAR, eax, 0
        INVOKE SendMessage, hWnd, EM_LINEINDEX, eax, 0
        mov    txtrange.chrg.cpMin, eax
        mov    FirstChar, eax
        INVOKE SendMessage, hWnd, EM_CHARFROMPOS, 0, ADDR rect.right
        mov    txtrange.chrg.cpMax, eax
        push   rect.left
        pop    RealRect.left
        push   rect.top
        pop    RealRect.top
        push   rect.right
        pop    RealRect.right
        push   rect.bottom
        pop    RealRect.bottom
        INVOKE CreateRectRgn, RealRect.left, RealRect.top,
                              RealRect.right, RealRect.bottom
        mov    hRgn, eax
        INVOKE SelectObject, hdc, hRgn
        mov    hOldRgn, eax
        INVOKE SetTextColor, hdc, CmntColor

; Pobieramy widoczny tekst do bufora

        lea    eax, buffer
        mov    txtrange.lpstrText, eax
        INVOKE SendMessage, hWnd, EM_GETTEXTRANGE, 0, ADDR txtrange
        mov    esi, eax        ; esi == rozmiar tekstu
        .IF esi>0
            mov BufferSize, eax

; Najpierw szukamy komentarza

            push edi
            push ebx
            lea  edi, buffer
            mov  edx, edi        ; uywane jako punkt odniesienia
            mov  ecx, esi
            mov  al, ";"

ScanMore:
            repne scasb
            je    NextSkip
            jmp   NoMoreHit

NextSkip:
            dec   edi
            inc   ecx
            mov   pString, edi
            mov   ebx, edi
            sub   ebx, edx
            add   ebx, FirstChar
            mov   txtrange.chrg.cpMin, ebx

; Szukamy koca wiersza lub koca bufora

            push  eax
            mov   al, 0Dh
            repne scasb
            pop   eax

HiliteTheComment:

            .IF ecx>0
                mov BYTE PTR [edi-1], 0
            .ENDIF
            mov ebx, edi
            sub ebx, edx
            add ebx, FirstChar
            mov txtrange.chrg.cpMax, ebx
            pushad

; Teraz wyszukujemy w zakresie tabulacje

            mov  edi, pString
            mov  esi, txtrange.chrg.cpMax
            sub  esi, txtrange.chrg.cpMin ; esi zawiera dugo bufora
            mov  eax, esi
            push edi
            .WHILE eax>0
                .IF BYTE PTR [edi]==9
                    mov BYTE PTR [edi], 0
                .ENDIF
                inc edi
                dec eax
            .ENDW
            pop edi
            .WHILE esi>0
                .IF BYTE PTR [edi]!=0
                    INVOKE lstrlen, edi
                    push   eax
                    mov    ecx, edi
                    lea    edx, buffer
                    sub    ecx, edx
                    add    ecx, FirstChar
                    .IF RichEditVersion==3
                        INVOKE SendMessage, hWnd, EM_POSFROMCHAR,
                                            ADDR rect, ecx
                    .ELSE
                        INVOKE SendMessage, hWnd, EM_POSFROMCHAR, ecx, 0
                        mov    ecx, eax
                        and    ecx, 0FFFFh
                        mov    rect.left, ecx
                        shr    eax, 16
                        mov    rect.top, eax
                    .ENDIF
                    INVOKE DrawText, hdc, edi, -1, ADDR rect, 0
                    pop    eax
                    add    edi, eax
                    sub    esi, eax
                .ELSE
                    inc edi
                    dec esi
                .ENDIF            
            .ENDW
            mov    ecx, txtrange.chrg.cpMax
            sub    ecx, txtrange.chrg.cpMin
            INVOKE RtlZeroMemory, pString, ecx
            popad
            .IF ecx>0
                jmp ScanMore
            .ENDIF
    NoMoreHit:
            pop ebx
            pop edi

; Gdy mamy za sob komentarze, pozbdmy si separatorw

            mov ecx, BufferSize
            lea esi, buffer
            .WHILE ecx>0
                mov al, BYTE PTR [esi]
                .IF al==" " || al==0Dh || al=="/" || al=="," ||\
                    al=="|" || al=="+" || al=="-" || al=="*" ||\
                    al=="&" || al=="<" || al==">" || al=="=" ||\
                    al=="(" || al==")" || al=="{" || al=="}" ||\
                    al=="[" || al=="]" || al=="^" || al==":" || al==9
                    mov BYTE PTR [esi], 0
                .ENDIF
                dec ecx
                inc esi
            .ENDW

; Rozpoczynamy wyszukiwanie

            lea esi, buffer
            mov ecx, BufferSize
            .WHILE ecx>0
                mov al, BYTE PTR [esi]
                .IF al!=0
                    push   ecx
                    INVOKE lstrlen, esi
                    push   eax
                    mov    edx, eax  ; edx zawiera dugo acucha
                    movzx  eax, BYTE PTR [esi]
                    .IF al>="A" && al<="Z"
                        add al, 32
                    .ENDIF
                    shl eax, 2
                    add eax, edi  ; edi zawiera wskazanie tablicy wskaza WORDINFO
                    .IF DWORD PTR [eax]!=0
                        mov eax, dword PTR [eax]

ASSUME eax:PTR WORDINFO

                        .WHILE eax!=0
                            .IF edx==[eax].WordLen
                                pushad
                                INVOKE lstrcmpi, [eax].pszWord, esi
                                .IF eax==0                                
                                    popad

; Podwietlamy sowo

                                    mov ecx, esi
                                    lea edx, buffer
                                    sub ecx, edx
                                    add ecx, FirstChar
                                    pushad
                                    .IF RichEditVersion==3
                                        INVOKE SendMessage, hWnd,
                                                            EM_POSFROMCHAR,
                                                            ADDR rect, ecx
                                    .ELSE
                                        INVOKE SendMessage, hWnd,
                                                            EM_POSFROMCHAR,
                                                            ecx, 0
                                        mov    ecx, eax
                                        and    ecx, 0FFFFh
                                        mov    rect.left, ecx
                                        shr    eax, 16
                                        mov    rect.top, eax
                                    .ENDIF
                                    popad
                                    mov    edx, [eax].pColor
                                    INVOKE SetTextColor, hdc,
                                                         DWORD PTR [edx]                                
                                    INVOKE DrawText, hdc, esi, -1,
                                                         ADDR rect, 0
                                    .BREAK
                                .ENDIF
                                popad
                            .ENDIF
                            push [eax].NextLink
                            pop  eax
                        .ENDW
                    .ENDIF
                    pop eax
                    pop ecx
                    add esi, eax
                    sub ecx, eax
                .ELSE
                    inc esi
                    dec ecx
                .ENDIF
            .ENDW
        .ENDIF
        INVOKE SelectObject, hdc, hOldRgn
        INVOKE DeleteObject, hRgn
        INVOKE SelectObject, hdc, hOldFont
        INVOKE ReleaseDC, hWnd, hdc
        INVOKE ShowCaret, hWnd
        pop    eax
        pop    esi
        pop    edi
        ret
    .ELSEIF uMsg==WM_CLOSE
        INVOKE SetWindowLong, hWnd, GWL_WNDPROC, OldWndProc        
    .ELSE
        INVOKE CallWindowProc, OldWndProc, hWnd, uMsg, wParam, lParam
        ret
    .ENDIF

NewRichEditProc ENDP

WndProc PROC hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

LOCAL ofn:         OPENFILENAME
LOCAL buffer[256]: BYTE
LOCAL editstream:  EDITSTREAM
LOCAL hFile:       DWORD
LOCAL hPopup:      DWORD
LOCAL pt:          POINT
LOCAL chrg:        CHARRANGE

    .IF uMsg==WM_CREATE
        INVOKE CreateWindowEx, WS_EX_CLIENTEDGE, ADDR RichEditClass,
                               0, WS_CHILD OR WS_VISIBLE OR \
                               ES_MULTILINE OR WS_VSCROLL OR \
                               WS_HSCROLL OR ES_NOHIDESEL, CW_USEDEFAULT,
                               CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
                               hWnd, RichEditID, hInstance, 0
        mov    hwndRichEdit, eax

; Sprawdzamy wersj kontrolki RichEdit

        INVOKE SendMessage, hwndRichEdit, EM_SETTYPOGRAPHYOPTIONS,
                            TO_SIMPLELINEBREAK, TO_SIMPLELINEBREAK
        INVOKE SendMessage, hwndRichEdit, EM_GETTYPOGRAPHYOPTIONS, 1, 1
        .IF eax==0        ; oznacza, i ta wiadomo jest nieobecna
            mov RichEditVersion, 2
        .ELSE
            mov RichEditVersion, 3

; Wczamy emulacj systemowej kontrolki edycyjnej, aby
; uaktualnienie kolorw nie zajmowao zbyt wiele czasu

            INVOKE SendMessage, hwndRichEdit, EM_SETEDITSTYLE,
                                SES_EMULATESYSEDIT, SES_EMULATESYSEDIT
        .ENDIF

; Przechwytujemy procedur okna kontrolki RichEdit

        INVOKE SetWindowLong, hwndRichEdit, GWL_WNDPROC,
                              ADDR NewRichEditProc
        mov    OldWndProc, eax

; Zmieniamy pojemno tekstu. Standardowo jest 64KB

        INVOKE SendMessage, hwndRichEdit, EM_LIMITTEXT, -1, 0

; Ustawiamy standardowe kolory tekstu i ta

        INVOKE SetColor
        INVOKE SendMessage, hwndRichEdit, EM_SETMODIFY, FALSE, 0

; Ustawiamy mask zdarze

        INVOKE SendMessage, hwndRichEdit, EM_SETEVENTMASK, 0,
                            ENM_MOUSEEVENTS
        INVOKE SendMessage, hwndRichEdit, EM_EMPTYUNDOBUFFER, 0, 0
    .ELSEIF uMsg==WM_NOTIFY
        push esi
        mov  esi, lParam

ASSUME esi:PTR NMHDR

        .IF [esi].code==EN_MSGFILTER

ASSUME esi:PTR MSGFILTER

            .IF [esi].msg==WM_RBUTTONDOWN
                INVOKE GetMenu, hWnd
                INVOKE GetSubMenu, eax, 1
                mov    hPopup, eax
                INVOKE PrepareEditMenu, hPopup
                mov    edx, [esi].lParam
                mov    ecx, edx
                and    edx, 0FFFFh
                shr    ecx, 16
                mov    pt.x, edx
                mov    pt.y, ecx
                INVOKE ClientToScreen, hWnd, ADDR pt
                INVOKE TrackPopupMenu, hPopup, TPM_LEFTALIGN OR \
                                       TPM_BOTTOMALIGN, pt.x, pt.y,
                                       NULL, hWnd, NULL
            .ENDIF
        .ENDIF
        pop esi
    .ELSEIF uMsg==WM_INITMENUPOPUP
        mov eax, lParam
        .IF ax==0                   ; menu Plik
            .IF FileOpened==TRUE    ; plik jest ju otwarty
                INVOKE EnableMenuItem, wParam, IDM_OPEN, MF_GRAYED
                INVOKE EnableMenuItem, wParam, IDM_CLOSE, MF_ENABLED
                INVOKE EnableMenuItem, wParam, IDM_SAVE, MF_ENABLED
                INVOKE EnableMenuItem, wParam, IDM_SAVEAS, MF_ENABLED
            .ELSE
                INVOKE EnableMenuItem, wParam, IDM_OPEN, MF_ENABLED
                INVOKE EnableMenuItem, wParam, IDM_CLOSE, MF_GRAYED
                INVOKE EnableMenuItem, wParam, IDM_SAVE, MF_GRAYED
                INVOKE EnableMenuItem, wParam, IDM_SAVEAS, MF_GRAYED
            .ENDIF
        .ELSEIF ax==1               ; menu Edycja
            INVOKE PrepareEditMenu, wParam
        .ELSEIF ax==2               ; menu Szukaj
            .IF FileOpened==TRUE
                INVOKE EnableMenuItem, wParam, IDM_FIND, MF_ENABLED
                INVOKE EnableMenuItem, wParam, IDM_FINDNEXT, MF_ENABLED
                INVOKE EnableMenuItem, wParam, IDM_FINDPREV, MF_ENABLED
                INVOKE EnableMenuItem, wParam, IDM_REPLACE, MF_ENABLED
                INVOKE EnableMenuItem, wParam, IDM_GOTOLINE, MF_ENABLED
            .ELSE
                INVOKE EnableMenuItem, wParam, IDM_FIND, MF_GRAYED
                INVOKE EnableMenuItem, wParam, IDM_FINDNEXT, MF_GRAYED
                INVOKE EnableMenuItem, wParam, IDM_FINDPREV, MF_GRAYED
                INVOKE EnableMenuItem, wParam, IDM_REPLACE, MF_GRAYED
                INVOKE EnableMenuItem, wParam, IDM_GOTOLINE, MF_GRAYED
            .ENDIF
        .ENDIF
    .ELSEIF uMsg==WM_COMMAND
        .IF lParam==0        ; polecenia menu
            mov eax, wParam
            .IF ax==IDM_OPEN
                INVOKE RtlZeroMemory, ADDR ofn, SIZEOF ofn
                mov    ofn.lStructSize, SIZEOF ofn
                push   hWnd
                pop    ofn.hwndOwner
                push   hInstance
                pop    ofn.hInstance
                mov    ofn.lpstrFilter, OFFSET ASMFilterString
                mov    ofn.lpstrFile, OFFSET FileName
                mov    BYTE PTR [FileName], 0
                mov    ofn.nMaxFile, SIZEOF FileName
                mov    ofn.Flags, OFN_FILEMUSTEXIST OR \
                                  OFN_HIDEREADONLY OR OFN_PATHMUSTEXIST
                INVOKE GetOpenFileName, ADDR ofn
                .IF eax!=0
                    INVOKE CreateFile, ADDR FileName, GENERIC_READ,
                                       FILE_SHARE_READ, NULL, OPEN_EXISTING,
                                       FILE_ATTRIBUTE_NORMAL, 0
                    .IF eax!=INVALID_HANDLE_VALUE
                        mov hFile, eax

; Strumie tekstu do kontrolki RichEdit

                        mov    editstream.dwCookie, eax
                        mov    editstream.pfnCallback, OFFSET StreamInProc
                        INVOKE SendMessage, hwndRichEdit, EM_STREAMIN,
                                            SF_TEXT, ADDR editstream

; Inicjujemy stan modyfikacji na FALSE

                        INVOKE SendMessage, hwndRichEdit, EM_SETMODIFY,
                                            FALSE, 0
                        INVOKE CloseHandle, hFile
                        mov    FileOpened, TRUE
                    .ELSE
                        INVOKE MessageBox, hWnd, ADDR OpenFileFail, ADDR AppName,
                                           MB_OK OR MB_ICONERROR
                    .ENDIF
                .ENDIF
            .ELSEIF ax==IDM_CLOSE
                INVOKE CheckModifyState, hWnd
                .IF eax==TRUE
                    INVOKE SetWindowText, hwndRichEdit, 0
                    mov    FileOpened, FALSE
                .ENDIF
            .ELSEIF ax==IDM_SAVE
                INVOKE CreateFile, ADDR FileName, GENERIC_WRITE,
                                   FILE_SHARE_READ, NULL, CREATE_ALWAYS,
                                   FILE_ATTRIBUTE_NORMAL, 0
                .IF eax!=INVALID_HANDLE_VALUE
@@:                
                    mov hFile, eax

; Strumie tekstu do pliku

                    mov    editstream.dwCookie, eax
                    mov    editstream.pfnCallback, OFFSET StreamOutProc
                    INVOKE SendMessage, hwndRichEdit, EM_STREAMOUT,
                                        SF_TEXT, ADDR editstream

; Inicjujemy stan modyfikacji na FALSE

                    INVOKE SendMessage, hwndRichEdit, EM_SETMODIFY,
                                        FALSE, 0
                    INVOKE CloseHandle, hFile
                .ELSE
                    INVOKE MessageBox, hWnd, ADDR OpenFileFail, ADDR AppName,
                                       MB_OK OR MB_ICONERROR
                .ENDIF
            .ELSEIF ax==IDM_COPY
                INVOKE SendMessage, hwndRichEdit, WM_COPY, 0, 0
            .ELSEIF ax==IDM_CUT
                INVOKE SendMessage, hwndRichEdit, WM_CUT, 0, 0
            .ELSEIF ax==IDM_PASTE
                INVOKE SendMessage, hwndRichEdit, WM_PASTE, 0, 0
            .ELSEIF ax==IDM_DELETE
                INVOKE SendMessage, hwndRichEdit, EM_REPLACESEL, TRUE, 0
            .ELSEIF ax==IDM_SELECTALL
                mov    chrg.cpMin, 0
                mov    chrg.cpMax, -1
                INVOKE SendMessage, hwndRichEdit, EM_EXSETSEL, 0, ADDR chrg
            .ELSEIF ax==IDM_UNDO
                INVOKE SendMessage, hwndRichEdit, EM_UNDO, 0, 0
            .ELSEIF ax==IDM_REDO
                INVOKE SendMessage, hwndRichEdit, EM_REDO, 0, 0
            .ELSEIF ax==IDM_OPTION
                INVOKE DialogBoxParam, hInstance, IDD_OPTIONDLG, hWnd,
                                       ADDR OptionProc, 0
            .ELSEIF ax==IDM_SAVEAS
                INVOKE RtlZeroMemory, ADDR ofn, SIZEOF ofn
                mov    ofn.lStructSize, SIZEOF ofn
                push   hWnd
                pop    ofn.hwndOwner
                push   hInstance
                pop    ofn.hInstance
                mov    ofn.lpstrFilter, OFFSET ASMFilterString
                mov    ofn.lpstrFile, OFFSET AlternateFileName
                mov    BYTE PTR [AlternateFileName], 0
                mov    ofn.nMaxFile, SIZEOF AlternateFileName
                mov    ofn.Flags, OFN_FILEMUSTEXIST OR OFN_HIDEREADONLY OR \
                                  OFN_PATHMUSTEXIST
                INVOKE GetSaveFileName, ADDR ofn
                .IF eax!=0
                    INVOKE CreateFile, ADDR AlternateFileName, GENERIC_WRITE,
                                       FILE_SHARE_READ, NULL, CREATE_ALWAYS,
                                       FILE_ATTRIBUTE_NORMAL, 0
                    .IF eax!=INVALID_HANDLE_VALUE
                        jmp @B
                    .ENDIF
                .ENDIF
            .ELSEIF ax==IDM_FIND
                .IF hSearch==0
                    INVOKE CreateDialogParam, hInstance, IDD_FINDDLG, hWnd,
                                              ADDR SearchProc, 0
                .ENDIF
            .ELSEIF ax==IDM_REPLACE
                .IF hSearch==0
                    INVOKE CreateDialogParam, hInstance, IDD_REPLACEDLG, hWnd,
                                              ADDR ReplaceProc, 0
                .ENDIF
            .ELSEIF ax==IDM_GOTOLINE
                .IF hSearch==0
                    INVOKE CreateDialogParam, hInstance, IDD_GOTODLG, hWnd,
                                              ADDR GoToProc, 0
                .ENDIF
            .ELSEIF ax==IDM_FINDNEXT
                INVOKE lstrlen, ADDR FindBuffer
                .IF eax!=0
                    INVOKE SendMessage, hwndRichEdit, EM_EXGETSEL, 0,
                                        ADDR findtext.chrg
                    mov    eax, findtext.chrg.cpMin
                    .IF eax!=findtext.chrg.cpMax
                        push findtext.chrg.cpMax
                        pop  findtext.chrg.cpMin
                    .ENDIF
                    mov    findtext.chrg.cpMax, -1
                    mov    findtext.lpstrText, OFFSET FindBuffer
                    INVOKE SendMessage, hwndRichEdit, EM_FINDTEXTEX, FR_DOWN,
                                        ADDR findtext
                    .IF eax!=-1
                        INVOKE SendMessage, hwndRichEdit, EM_EXSETSEL, 0,
                                            ADDR findtext.chrgText
                    .ENDIF
                .ENDIF
            .ELSEIF ax==IDM_FINDPREV
                INVOKE lstrlen, ADDR FindBuffer
                .IF eax!=0
                    INVOKE SendMessage, hwndRichEdit, EM_EXGETSEL, 0,
                                        ADDR findtext.chrg
                    mov    findtext.chrg.cpMax, 0
                    mov    findtext.lpstrText, OFFSET FindBuffer
                    INVOKE SendMessage, hwndRichEdit, EM_FINDTEXTEX, 0,
                                        ADDR findtext
                    .IF eax!=-1
                        INVOKE SendMessage, hwndRichEdit, EM_EXSETSEL,
                                            0, ADDR findtext.chrgText
                    .ENDIF
                .ENDIF
            .ELSEIF ax==IDM_EXIT
                INVOKE SendMessage, hWnd, WM_CLOSE, 0, 0
            .ENDIF
        .ENDIF
    .ELSEIF uMsg==WM_CLOSE
        INVOKE CheckModifyState, hWnd
        .IF eax==TRUE
            INVOKE DestroyWindow, hWnd
        .ENDIF
    .ELSEIF uMsg==WM_SIZE
        movzx  eax, WORD PTR lParam
        movzx  edx, WORD PTR lParam + 2
        INVOKE MoveWindow, hwndRichEdit, 0, 0, eax, edx, TRUE        
    .ELSEIF uMsg==WM_DESTROY
        INVOKE PostQuitMessage, NULL
    .ELSE
        INVOKE DefWindowProc, hWnd, uMsg, wParam, lParam        
        ret
    .ENDIF
    xor eax, eax
    ret

WndProc ENDP

END start